Index: /branches/v2.9_Lars/JPGPROC/source/makefile
===================================================================
--- /branches/v2.9_Lars/JPGPROC/source/makefile	(revision 135)
+++ /branches/v2.9_Lars/JPGPROC/source/makefile	(revision 136)
@@ -45,4 +45,5 @@
 #
 #################################################################################
+include ../../make.inc
 
 .SUFFIXES: .exe .obj .asm .inc .def .lrf .lst .sym .map .c .h .lib .dlg .txt .cod  \
@@ -60,6 +61,5 @@
 #################################
 MAPSYM=mapsym
-GMBLIBPATH= D:/usr/lib/GBM
-LIBS=	MMPM2.LIB $(GMBLIBPATH)/GBM.LIB
+LIBS=	MMPM2.LIB $(GBMLIBPATH)/GBM.LIB
 LDFLAGS =	-Ge- /Gm+ -G4 /ss -Gl /O+ -Oc+ -Ol-  /Q+ /B"/NOE"
 
@@ -96,5 +96,5 @@
 	-rm *.obj
 	-rm *.dll
-	-rm *.res
+	-rm *.RES
 	-rm *.*~
 	-rm *.map
Index: /branches/v2.9_Lars/LocalEnv.cmd.tpl
===================================================================
--- /branches/v2.9_Lars/LocalEnv.cmd.tpl	(revision 135)
+++ /branches/v2.9_Lars/LocalEnv.cmd.tpl	(revision 136)
@@ -47,3 +47,9 @@
  */
 
-G.PATH_TOOL_SOM_ENV     = 'U:\Toolkit\SOM\bin\somenv.cmd'
+G.PATH_TOOL_SOM_ENV     = 'U:\Toolkit\SOM\bin\somenv.cmd'     
+
+/**
+ * Set MAKESHELL to either cmd.exe or 4os2.exe as sh chokes on backslashes
+ */
+
+G.MAKESHELL            = 'G:\4os2\4os2.exe'
Index: /branches/v2.9_Lars/classes/c/c_mm/mmfolder.c
===================================================================
--- /branches/v2.9_Lars/classes/c/c_mm/mmfolder.c	(revision 135)
+++ /branches/v2.9_Lars/classes/c/c_mm/mmfolder.c	(revision 136)
@@ -585,5 +585,5 @@
                   else if(_somIsA(wpObject, cwBitmapClass)) {
                     hbm=MMBitmap_cwmmQuerySmallBitmapHandle( (MMBitmap*) wpObject, ulIconSize);
-                    pBmpInfoHeader2=(PBITMAPINFOHEADER2)_wpQueryBitmapInfoHeader((MMBitmap*)wpObject);
+                    pBmpInfoHeader2=(PBITMAPINFOHEADER2)_cwmmQueryBitmapInfoHeader((MMBitmap*)wpObject);
                   }
                   if(hbm)
Index: /branches/v2.9_Lars/classes/mm-progs/videoplayer/makefile
===================================================================
--- /branches/v2.9_Lars/classes/mm-progs/videoplayer/makefile	(revision 135)
+++ /branches/v2.9_Lars/classes/mm-progs/videoplayer/makefile	(revision 136)
@@ -41,4 +41,5 @@
 	-rm *.RES
 	-rm *.ini
+	-rm *.def
 
 cleaner:
Index: /branches/v2.9_Lars/classes/mm-progs/volume/makefile
===================================================================
--- /branches/v2.9_Lars/classes/mm-progs/volume/makefile	(revision 135)
+++ /branches/v2.9_Lars/classes/mm-progs/volume/makefile	(revision 136)
@@ -29,4 +29,5 @@
 	-rm *.ini
 	-rm $(LIBDIR)/*.obj
+	-rm *.def
 
 cleaner:
Index: /branches/v2.9_Lars/common_functions/makefile
===================================================================
--- /branches/v2.9_Lars/common_functions/makefile	(revision 135)
+++ /branches/v2.9_Lars/common_functions/makefile	(revision 136)
@@ -3,8 +3,8 @@
 #include ../make.inc
 
-CC           = gcc
+CC           = icc
 LIB_DIR      = D:/usr/lib 
-#CPPFLAGS     = -Ge- /Gm+ -G4 -Gl  /O+ -Oc+ -Ol
-CPPFLAGS     = -O -Zomf -Zcrtdll -s
+CPPFLAGS     = -Ge- /Gm+ -G4 -Gl  /O+ -Oc+ -Ol
+#CPPFLAGS     = -O -Zomf -Zcrtdll -s
 INC		= ../include
 DEFS         =
Index: /branches/v2.9_Lars/env.cmd
===================================================================
--- /branches/v2.9_Lars/env.cmd	(revision 135)
+++ /branches/v2.9_Lars/env.cmd	(revision 136)
@@ -53,4 +53,6 @@
 call EnvSet 'EMXOMFLD_TYPE','wlink'
 call EnvSet 'EMXOMFLD_LINKER', 'wl.exe'
+call EnvSet 'MAKESHELL', translate(G.MAKESHELL, '/', '\')
+call EnvSet 'GBMLIBPATH', translate(G.GBMLIBPATH, '/', '\')
 
 /* set path amd beginlib path for building the wpi*/
Index: /branches/v2.9_Lars/make.inc
===================================================================
--- /branches/v2.9_Lars/make.inc	(revision 135)
+++ /branches/v2.9_Lars/make.inc	(revision 136)
@@ -1,4 +1,4 @@
 # List of languages to be built.
-LANGUAGES	=	de en es fr nl it tw
+LANGUAGES	=	de en es fr nl it ru tw
 
 #define the next makro if compiling a release rather than a beta
@@ -23,4 +23,5 @@
 AUTHOR_STRING	=	"(C) Chris Wohlgemuth 2002-2005 Gregg Young 2023"
 BUILD_ROOT      =       D:/cwmm/branches/v2.9_Lars
+GBMLIBPATH      =       U:/usr/lib/GBM
 
 # Put version in environment for REXX skripts
Index: /branches/v2.9_Lars/makefile
===================================================================
--- /branches/v2.9_Lars/makefile	(revision 135)
+++ /branches/v2.9_Lars/makefile	(revision 136)
@@ -274,3 +274,2 @@
 bld:
 	@build.cmd
-
Index: /branches/v2.9_Lars/mediafolder/res/makefile
===================================================================
--- /branches/v2.9_Lars/mediafolder/res/makefile	(revision 135)
+++ /branches/v2.9_Lars/mediafolder/res/makefile	(revision 136)
@@ -56,5 +56,5 @@
 clean:
 	-cd $(OBJDIR) && rm *
-	-rm *.res
+	-rm *.RES
 
 cleaner:
Index: /branches/v2.9_Lars/nlv/de/classes/res/makefile
===================================================================
--- /branches/v2.9_Lars/nlv/de/classes/res/makefile	(revision 135)
+++ /branches/v2.9_Lars/nlv/de/classes/res/makefile	(revision 136)
@@ -35,4 +35,4 @@
 	-rm *.*~
 	-rm *.flc
-	-rm *.res
+	-rm *.RES
 	-rm *.obj
Index: /branches/v2.9_Lars/stream_ioproc/source/makefile
===================================================================
--- /branches/v2.9_Lars/stream_ioproc/source/makefile	(revision 135)
+++ /branches/v2.9_Lars/stream_ioproc/source/makefile	(revision 136)
@@ -97,5 +97,5 @@
 	-rm *.obj
 	-rm *.dll
-	-rm *.res
+	-rm *.RES
 	-rm *.*~
 	-rm *.map
Index: /branches/v2.9_Lars/warpin/Build_CWMM.cmd
===================================================================
--- /branches/v2.9_Lars/warpin/Build_CWMM.cmd	(revision 136)
+++ /branches/v2.9_Lars/warpin/Build_CWMM.cmd	(revision 136)
@@ -0,0 +1,122 @@
+/*
+        Build_CWMM.cmd:
+        this uses WIC.EXE to create an archive called
+        CWMM.WPI, containing the CWMM program
+        (C) VOICE 
+*/
+
+/* Set DEBUG=1 to output diagnostic information, and pause, while building */
+DEBUG=0
+
+/* Load the REXX Funcs library */
+call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
+call SysLoadFuncs
+
+/* Big screen, so you can see what happened */
+"@MODE Co80,43"
+
+/* Find out where warpIn is. */
+origdir = directory();
+warpindir=SysIni('USER', 'WarpIN', 'Path')
+warpindir=left(warpindir,length(warpindir)-1)
+
+/* set the ENDLIBPATH */
+"@SET ENDLIBPATH="warpindir
+
+If DEBUG=1 then Do
+  SAY "Wic.exe is found in: "warpindir
+  SAY "Press any key to continue"
+  a=SysGetKey()
+end
+
+/*call directory origdir*/
+
+/* set package name */
+pkgname='CWMM'
+
+/*x = lastpos("\",origdir)
+pkgname=right(origdir,length(origdir)-x)*/
+
+If DEBUG=1 then Do
+  SAY "Package name: "pkgname
+  SAY "Press any key to continue"
+  a=SysGetKey()
+end
+
+/* get environment variables for major/minor/revision/fixlevel */
+major=VALUE('CWMMMAJOR',,'OS2ENVIRONMENT')
+minor=VALUE('CWMMMINOR',,'OS2ENVIRONMENT')
+revision=VALUE('CWMMREVISION',,'OS2ENVIRONMENT')
+fixlevel=VALUE('CWMMFIXLEVEL',,'OS2ENVIRONMENT')
+
+if major=''|minor=''|revision='' then Do
+  /* If the environment variables are not set, ask for version number */
+  version = ''
+  SAY 
+  SAY "Please enter the 3, or 4, digit version number, in the form 1\2\3 or 1\2\3\4 : "
+
+  PARSE PULL major'\'minor'\'revision'\'fixlevel
+end
+
+/* This is where the version information is added to the file name */
+if fixlevel='' then do
+   version=major'\'minor'\'revision
+   fileversion='-'major'-'minor'-'revision
+end
+else Do
+   version=major'\'minor'\'revision'\'fixlevel
+   fileversion='-'major'-'minor'-'revision'-'fixlevel
+end
+
+If DEBUG=1 then Do
+  SAY "The WarpIn installer file name will be: "pkgname||fileversion".WPI"
+  SAY "Press any key to continue"
+  a=SysGetKey()
+end
+
+/* Now, update the package.wis file to add the version information */
+InName=pkgname||".wis" 
+OutName=pkgname||fileversion||".wis"
+DO UNTIL (lines(InName)=0)
+  linex=linein(InName)
+  If POS('PACKAGEID="Netlabs\CWMM',linex)>0 then Do
+    linex=linex||version||'"'
+  end
+  rc=lineout(Outname,linex)
+END
+call stream OutName, "C", "CLOSE"	/* close them */
+call stream InName, "C", "CLOSE"
+
+If DEBUG=1 then Do
+  /* display the resulting WIS file */
+  "@E.EXE "OutName
+end
+
+/* Create the packages as a WPI file */
+/* Package 1 prog.dll */
+warpindir"\wic.exe "pkgname||fileversion" -a 1 -r -cOS2DLL * -s "||pkgname||fileversion||".wis"
+
+/* Package 2 CW Multimedia classes */
+warpindir"\wic.exe "pkgname||fileversion" -a 2 -r -cMMCLASS * -s "||pkgname||fileversion||".wis"
+
+/* Package 3 Media folder */
+warpindir"\wic.exe "pkgname||fileversion" -a 3 -r -cMEDIAFLD * -s "||pkgname||fileversion||".wis"
+
+/* Package 4 JPEGIO.DLL */
+warpindir"\wic.exe "pkgname||fileversion" -a 4 -r -cDLL * -s "||pkgname||fileversion||".wis"
+
+/* Package 5 FreeDB */
+warpindir"\wic.exe "pkgname||fileversion" -a 5 -r -cFREEDB * -s "||pkgname||fileversion||".wis"
+
+If DEBUG=1 then Do
+  SAY "Save the results? [Y/N]"
+  PARSE UPPER PULL answer
+end
+
+IF answer = "Y"|DEBUG=0 then DO
+   /* save the last attempt */
+   '@copy 'pkgname||fileversion'.* History'
+END
+"@del "pkgname||fileversion".*"
+
+exit
Index: /branches/v2.9_Lars/warpin/CWMM.wis
===================================================================
--- /branches/v2.9_Lars/warpin/CWMM.wis	(revision 136)
+++ /branches/v2.9_Lars/warpin/CWMM.wis	(revision 136)
@@ -0,0 +1,121 @@
+<WARPIN VERSION="1.0"
+CODEPAGE=850>
+
+<HEAD>
+
+    <REXX NAME="CheckDLL">
+        /* Searches the system LIBPATH for the specified DLL.  If not found,
+         * displays a popup dialog, and optionally aborts the installation.
+         *
+         * Parameters:
+         *      dname   Name of the DLL to look for (must include extension)
+         *      fail    If 1, abort installation if the DLL was not found
+         *      message Message text to be shown when the DLL is not found
+         */
+        CALL RxFuncAdd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
+        CALL SysLoadFuncs
+
+        PARSE ARG dname fail message
+        IF dname == '' THEN RETURN ''
+
+        _bd = SysBootDrive()
+        IF _bd == '' THEN
+            _bd = FILESPEC('DRIVE', VALUE('COMSPEC',,'OS2ENVIRONMENT'))
+        _cwmm = _bd'\MMOS2\MMCLASS\'dname
+
+        call SysFileTree _cwmm, 'file', 'FO'
+
+        IF file.0 == 0 THEN DO
+            title = dname 'Not Found'
+            rc = WirexxShowMessage( title, message )
+            IF fail == 1 THEN CALL WirexxCancel
+        END
+
+        RETURN ''
+    </REXX>
+
+<PCK INDEX=1
+     PACKAGEID="Netlabs\CWMM\Progfld\
+     TARGET="?:\OS2\DLL"
+     TITLE="CWMM Progfld"
+     SELECT
+     NODESELECT
+     LONGFILENAMES
+     KILLPROCESS="progfld.dll"
+     FIXED
+     =("CheckDLL CWMM.DLL 1 Either this is not an ArcaOS system or MMOS2/CWMM is not installed. This installer can only be used to update an ArcaOS system with MMOS2/CWMM already installed.")
+     >This package contains the CWMM progfld utility.
+     </PCK>
+
+<PCK INDEX=2
+     PACKAGEID="Netlabs\CWMM\Classes\
+     TARGET="?:\MMOS2\MMCLASS"
+     BASE
+     TITLE="CWMM Classes"
+     SELECT
+     NODESELECT
+     LONGFILENAMES
+     KILLPROCESS="CWMM.dll"
+     FIXED
+     EXECUTE="cube {RL #EXTNAMES=# WITH #EXTNAMES=13,AVI,FLI,FLC,FLV,3GP,M4V,MKV,MP4.MTS.VOB.WMV.WEBM# (FIRST *ID} ?:\MMOS2\MMPM2.INI ?:\MMOS2\MMPM2.BCK (DLM #"
+     CREATEOBJECT="WPProgram|CWMMConfig|<MMPM2_FOLDER>|EXENAME=$(2)\CWMMConfig.exe;OBJECTID=<CWMMCONFIG>"
+     >Contains the CWMM classes files.
+     </PCK>
+
+<PCK INDEX=3
+     PACKAGEID="Netlabs\CWMM\MediaFolder\
+     TARGET="?:\MMOS2\MEDIAFLD"
+     TITLE="CWMM Media Folder"
+     SELECT
+     NODESELECT
+     LONGFILENAMES
+     FIXED
+     >Contains the CWMM Media Folder.
+     </PCK>
+     
+<PCK INDEX=4
+     PACKAGEID="Netlabs\CWMM\JPEGIO\
+     TARGET="?:\MMOS2\DLL"
+     TITLE="JPEG IO plugin"
+     SELECT
+     LONGFILENAMES
+     FIXED
+     >Contains the JPEG IO DLL.
+     </PCK>
+
+<PCK INDEX=5
+     PACKAGEID="Netlabs\CWMM\FreeDB\
+     TARGET="?:\MMOS2\FREEDB"
+     TITLE="CWMM Free CD Database"
+     FIXED
+     >Contains the Free CD Database
+     </PCK>
+
+</HEAD>
+
+<BODY>
+
+<PAGE INDEX=1 TYPE=README>
+<NEXTBUTTON TARGET=2>~Next</NEXTBUTTON>
+<TEXT>This package will install CWMM.</TEXT>
+<README>NOTE: This installer will only work on an ARCOS system with MMOS2 installed</README>  
+</PAGE>
+
+<PAGE INDEX=2 TYPE=README>
+<NEXTBUTTON TARGET=3>~I agree</NEXTBUTTON>
+<TEXT>lSwitcher License: By pressing the "I agree" button, you agree to all terms and conditions of the license agreement below.</TEXT>
+<README EXTRACTFROMPCK="2">copying</README>
+</PAGE>
+
+<PAGE INDEX=3 TYPE=CONTAINER>
+    <TEXT>Please select the packages to install, and the target path(s).</TEXT>
+</PAGE>
+
+<PAGE INDEX=4 TYPE=CONFIGURE>
+    <TEXT>Select "Install" to begin the installation. You must reboot the system in order for the update to take effect</TEXT>
+    <NEXTBUTTON TARGET=0>~Install</NEXTBUTTON>
+</PAGE>
+
+</BODY>
+</WARPIN>
+
Index: /branches/v2.9_Lars/warpin/Prebuild_CWMM.cmd
===================================================================
--- /branches/v2.9_Lars/warpin/Prebuild_CWMM.cmd	(revision 136)
+++ /branches/v2.9_Lars/warpin/Prebuild_CWMM.cmd	(revision 136)
@@ -0,0 +1,43 @@
+rem CW-Multimedia classes  	
+	if not exist MMCLASS md MMCLASS
+        copy ..\classes\cwmm.dll MMCLASS
+	copy ..\classes\cwmm.sym MMCLASS
+	cd MMCLASS && lxlite *.dll && cd ..
+        if not exist MMCLASS\bin md MMCLASS\bin
+	copy ..\classes\mm-progs\audioconverter\audconv.exe MMCLASS\bin
+	copy ..\classes\mm-progs\master_volume\volume.exe MMCLASS\bin 
+	copy ..\classes\mm-progs\volume\classvol.exe MMCLASS\bin 
+	copy ..\classes\mm-progs\imageconverter\imgconv.exe MMCLASS\bin 
+	copy ..\classes\mm-progs\mmplayer\mmplayer.exe MMCLASS\bin 
+	copy ..\classes\mm-progs\mmfind\mmfind.exe MMCLASS\bin 
+	copy ..\classes\res\dll\mmres_EN.dll MMCLASS\bin
+	cd MMCLASS\bin && lxlite * && cd ..\..
+	copy ..\classes\bin\*.CMD MMCLASS\bin
+	copy ..\classes\bin\*.rx  MMCLASS\bin
+	copy ..\classes\help\en\cwmm.hlp MMCLASS
+   
+rem JPEG IO-Proc
+	if not exist DLL md DLL
+        copy ..\JPGPROC\source\JPEGIO.DLL DLL
+	copy ..\JPGPROC\source\JPEGIO.SYM DLL
+	cd DLL && lxlite *.dll && cd ..
+rem Mediafolder        
+        if not exist MEDIAFLD\Doc md MEDIAFLD\Doc
+        if not exist MEDIAFLD\bin md MEDIAFLD\bin
+        copy ..\mediafolder\prog_tutorial\mediafldrprog.inf MEDIAFLD\Doc\mediafldr.inf
+	copy ..\mediafolder\bin\*.cmd MEDIAFLD\bin
+	copy ..\mediafolder\bin\*.rx  MEDIAFLD\bin
+        if not exist OS2DLL md OS2DLL
+	copy ..\mediafolder\progfldr.dll OS2DLL
+	copy ..\mediafolder\c\createcd\createcd.exe  MEDIAFLD\bin
+	copy ..\mediafolder\mediafld.dll MEDIAFLD\bin\mediafld.dll
+	copy ..\mediafolder\res\obj\mfldr_en.dll MEDIAFLD\bin\mfldr_en.dll
+	copy ..\mediafolder\help\mediafldr.hlp MEDIAFLD\bin\mediafld.hlp
+        if not exist FreeDB md FreeDB
+	copy ..\mediafolder\c\cddb\pmcddb.exe FreeDB
+	copy ..\mediafolder\c\cddb\Res\pmcddb001.dll FreeDB\pmdb001.dll
+	copy ..\mediafolder\c\cddb\cddb.ini FreeDB
+	cd MEDIAFLD\bin && lxlite * && cd ..\..
+	cd OS2DLL && lxlite * && cd ..
+	cd FreeDB && lxlite * && cd ..
+Build_CWMM.cmd