Index: trunk/bootcode/airboot.asm
===================================================================
--- trunk/bootcode/airboot.asm	(revision 141)
+++ trunk/bootcode/airboot.asm	(revision 142)
@@ -1005,4 +1005,25 @@
         xor     ax, ax
         call    FillMemBlock
+
+; Initialize the com-port for debugging
+IFDEF   AUX_DEBUG
+        PUSHRF
+        ; Init com-port
+        call     AuxIO_Init
+        ; Hello message
+        mov     si, offset [AuxIOHello]
+        call    AuxIO_Print
+        ; Show Build Info
+        call    AuxIO_PrintBuildInfo
+        call    AuxIO_TeletypeNL
+        POPRF
+ENDIF
+
+; Dump debug information
+IFDEF   AUX_DEBUG
+    IF 1
+    call     DEBUG_Dump1
+    ENDIF
+ENDIF
 
 ; Verify we still got the BIOS disk in DL
Index: trunk/bootcode/regular/auxio.asm
===================================================================
--- trunk/bootcode/regular/auxio.asm	(revision 141)
+++ trunk/bootcode/regular/auxio.asm	(revision 142)
@@ -46,18 +46,7 @@
         jz      AuxIO_Init_NoLogging
 
+        ; Adjust to valid port range
         dec     dl                            ; adjust port-number
         and     dl,03h                        ; 3 is max value
-
-        ; Initialization message
-        mov     si,offset AuxInitMsg
-        call    MBR_Teletype
-
-        ; Port number
-        call    VideoIO_SyncPos
-        mov     al,dl
-        inc     al
-        call    VideoIO_PrintByteDynamicNumber
-        xor     si,si
-        call    MBR_TeletypeNL
 
         ; Do the initialization
@@ -75,71 +64,4 @@
 ;
 AuxIO_PrintBuildInfo    Proc    Near    Uses ax cx si di
-        ; Print header.
-        mov     si, offset build_info
-        call    AuxIO_Print
-
-        ; Prepare info in temorary buffer.
-        mov     si,offset bld_level_date_start
-        mov     cx,offset bld_level_date_end
-        sub     cx,si
-        mov     di,offset Scratch
-        cld
-        rep     movsb
-
-        ; Fill spaces until assembler specification.
-        mov     al,' '
-        mov     cx,37
-        rep     stosb
-
-        ; Copy assembler specification.
-    IFDEF       JWASM
-        mov     al,'['
-        stosb
-        mov     si,offset jwasm_txt
-    ELSEIFDEF   TASM
-        mov     al,' '
-        stosb
-        mov     al,'['
-        stosb
-        mov     si,offset tasm_txt
-
-    ELSEIFDEF   WASM
-        mov     al,' '
-        stosb
-        mov     al,'['
-        stosb
-        mov     si,offset wasm_txt
-    ELSEIFDEF   MASM
-        mov     al,' '
-        stosb
-        mov     al,'['
-        stosb
-        mov     si,offset masm_txt
-    ELSE
-        mov     al,' '
-        stosb
-        mov     al,'['
-        stosb
-        mov     si,offset unknown_txt
-    ENDIF
-
-    AuxIO_PrintBuildInfo_a1:
-        lodsb
-        test    al,al
-        jz      AuxIO_PrintBuildInfo_e1
-        stosb
-        jmp     AuxIO_PrintBuildInfo_a1
-    AuxIO_PrintBuildInfo_e1:
-        mov     al,']'
-        stosb
-
-        ; Insert NULL Terminator.
-        xor     al,al
-        stosb
-
-        ; Print Info.
-        mov     si, offset Scratch
-        call    AuxIO_Print
-        call    AuxIO_TeletypeNL
 
         ; OS/2 BLDLEVEL information.
@@ -435,5 +357,3 @@
 
 
-AuxIOHello  db 10,10,10,10,10,'AiR-BOOT com-port debugging',10,0
-
-
+AuxIOHello  db 10,10,10,'<<<<< AiR-BOOT SERIAL DEBUGGER ACTIVE >>>>>',10,0
Index: trunk/bootcode/regular/debug.asm
===================================================================
--- trunk/bootcode/regular/debug.asm	(revision 141)
+++ trunk/bootcode/regular/debug.asm	(revision 142)
@@ -908,17 +908,4 @@
         pusha
 
-        ; Hello message
-        mov     si, offset AuxIOHello
-        call    AuxIO_Print
-
-        ; Build Info
-        ;~ mov     si, offset BUILD_DATE
-        ;~ call    AuxIO_Print
-        call    AuxIO_PrintBuildInfo
-
-        ; Start new line
-        call    AuxIO_TeletypeNL
-        ;~ call    AuxIO_TeletypeNL
-
         ;~ call    DEBUG_DumpHidePartTables
         ;~ call    DEBUG_CheckMath
Index: trunk/bootcode/regular/other.asm
===================================================================
--- trunk/bootcode/regular/other.asm	(revision 141)
+++ trunk/bootcode/regular/other.asm	(revision 142)
@@ -91,5 +91,5 @@
 IFDEF   AUX_DEBUG
         IF 1
-        DBG_TEXT_OUT_AUX    'PRECRAP_Main'
+        DBG_TEXT_OUT_AUX    'PRECRAP_Main:'
         PUSHRF
             ;~ call    DEBUG_DumpRegisters
@@ -158,8 +158,25 @@
         call    VideoIO_PrintBuildInfo
 
-    IFDEF   AUX_DEBUG
-        ; Initialize the com-port for debugging
-        call     AuxIO_Init
-    ENDIF
+; Show message if com-port debugging is active
+IFDEF   AUX_DEBUG
+        ; Don't show message if com-port debugging is not active
+        mov     dx, [BIOS_AuxParms]
+        test    dl, dl
+        jz      @F
+
+        ; Show initialization message
+        mov     si, offset AuxInitMsg
+        call    MBR_Teletype
+
+        ; Sync output position
+        call    VideoIO_SyncPos
+
+        ; Show port number
+        mov     al, dl
+        call    VideoIO_PrintByteDynamicNumber
+        xor     si, si
+        call    MBR_TeletypeNL
+    @@:
+ENDIF
 
         xor     si,si
@@ -181,11 +198,4 @@
         ;! was loaded from a disk where the MBR cannot be written !
         ;!
-
-
-IFDEF   AUX_DEBUG
-    IF 1
-    call     DEBUG_Dump1
-    ENDIF
-ENDIF
 
 