Index: trunk/src/emx/include/check.cmd
===================================================================
--- trunk/src/emx/include/check.cmd	(revision 142)
+++ 	(revision )
@@ -1,3 +1,0 @@
-/* check.cmd */
-
-'gfind . -type f -print | xargs grep -f check.re'
Index: trunk/src/emx/include/check.re
===================================================================
--- trunk/src/emx/include/check.re	(revision 142)
+++ 	(revision )
@@ -1,1 +1,0 @@
-^#[ 	]*include[ 	]\+[<"]\(.*/\)*[^./]\{9,\}\(\.[ch]\|\.cc\|\)[>"]
Index: trunk/src/emx/include/emx/io.h
===================================================================
--- trunk/src/emx/include/emx/io.h	(revision 142)
+++ trunk/src/emx/include/emx/io.h	(revision 143)
@@ -226,5 +226,5 @@
 int *_fd_init (int);
 int *_fd_lookahead (int);
-struct _FILE *_fopen (struct _FILE *, __const__ char *, __const__ char *,
+struct _FILE *_openstream (struct _FILE *, __const__ char *, __const__ char *,
     int, int);
 int _flushstream (struct _FILE *, int);
Index: trunk/src/emx/include/emx/syscalls.h
===================================================================
--- trunk/src/emx/include/emx/syscalls.h	(revision 142)
+++ trunk/src/emx/include/emx/syscalls.h	(revision 143)
@@ -177,5 +177,4 @@
 int __listen (int handle, int backlog);
 int __lseek (int handle, long offset, int origin);
-void *__memaccess (unsigned first, unsigned last, int flag);
 int __memavail (void);
 int __mkdir (__const__ char *name);
@@ -184,7 +183,6 @@
 void __nls_memupr (unsigned char *buf, size_t size);
 int __open (__const__ char *name, int flags, unsigned long size);
-void __pause (void);
+int __pause (void);
 int __pipe (int *two_handles, int pipe_size);
-int __portaccess (unsigned first, unsigned last);
 int __profil (__const__ struct _profil *p);
 int __ptrace (int request, int pid, int addr, int data);
@@ -204,5 +202,4 @@
 int __setsockopt (int handle, int level, int optname, __const__ void *optval,
     int optlen);
-int __setsyserrno (int e);
 int __settime (const struct timeval *tp);
 int __shutdown (int handle, int how);
@@ -219,5 +216,4 @@
 int __stat (__const__ char *name, struct stat *buffer);
 int __swchar (int flag, int new_char);
-int __syserrno (void);
 int __uflags (int mask, int new_flags);
 long __ulimit (int cmd, long new_limit);
Index: trunk/src/emx/include/emx/time.h
===================================================================
--- trunk/src/emx/include/emx/time.h	(revision 142)
+++ trunk/src/emx/include/emx/time.h	(revision 143)
@@ -30,7 +30,7 @@
 extern struct _tzinfo _tzi;
 
-extern int const _year_day[_YEARS+1];
-extern int const _month_day_leap[];
-extern int const _month_day_non_leap[];
+extern unsigned short const _year_day[_YEARS+1];
+extern unsigned short const _month_day_leap[];
+extern unsigned short const _month_day_non_leap[];
 
 
Index: trunk/src/emx/include/long.cmd
===================================================================
--- trunk/src/emx/include/long.cmd	(revision 142)
+++ 	(revision )
@@ -1,38 +1,0 @@
-/* long.cmd */
-
-'@echo off'
-
-call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
-call SysLoadFuncs
-
-if SysSearchPath('PATH', 'sed.exe') == '' then do
-  say 'sed.exe not found -- see INSTALL.DOC'
-  exit
-end
-
-say 'Renaming files'
-do while lines('longshrt.ls1')
-  line = linein('longshrt.ls1')
-  parse var line long short
-  file = filespec('path', translate(long, '\', '/'))||short
-  new = filespec('name', long)
-  if stream(file, 'C', 'QUERY EXISTS') \= '' then
-    'ren' file new
-end
-
-do while lines('longshrt.ls2')
-  file = translate(linein('longshrt.ls2'), '\', '/')
-  if stream(file, 'C', 'QUERY EXISTS') \= '' then do
-    say 'Patching' file
-    'sed -f long.sed >tmp' file
-    if rc \= 0 then do
-      say 'sed failed!'
-      exit
-    end
-    'touch -r' file 'tmp'
-    'del' file
-    'move tmp' file '>nul'
-  end
-end
-
-say 'Done'
Index: trunk/src/emx/include/long.sed
===================================================================
--- trunk/src/emx/include/long.sed	(revision 142)
+++ 	(revision )
@@ -1,49 +1,0 @@
-/^#[ 	]*include/s|\([<"/]\)algorith\([">]\)|\1algorithm\2|
-/^#[ 	]*include/s|\([<"/]\)AllocRin\.h\([">]\)|\1AllocRing\.h\2|
-/^#[ 	]*include/s|\([<"/]\)BitStrin\.h\([">]\)|\1BitString\.h\2|
-/^#[ 	]*include/s|\([<"/]\)builtinb\.h\([">]\)|\1builtinbuf\.h\2|
-/^#[ 	]*include/s|\([<"/]\)exceptio\([">]\)|\1exception\2|
-/^#[ 	]*include/s|\([<"/]\)function\([">]\)|\1functional\2|
-/^#[ 	]*include/s|\([<"/]\)SplayNod\.ccP\([">]\)|\1SplayNode\.ccP\2|
-/^#[ 	]*include/s|\([<"/]\)SplayNod\.hP\([">]\)|\1SplayNode\.hP\2|
-/^#[ 	]*include/s|\([<"/]\)getpages\.h\([">]\)|\1getpagesize\.h\2|
-/^#[ 	]*include/s|\([<"/]\)hashtabl\.h\([">]\)|\1hashtable\.h\2|
-/^#[ 	]*include/s|\([<"/]\)Incremen\.h\([">]\)|\1Incremental\.h\2|
-/^#[ 	]*include/s|\([<"/]\)indstrea\.h\([">]\)|\1indstream\.h\2|
-/^#[ 	]*include/s|\([<"/]\)parsestr\.h\([">]\)|\1parsestream\.h\2|
-/^#[ 	]*include/s|\([<"/]\)ldcomple\.h\([">]\)|\1ldcomplex\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stdexcep\([">]\)|\1stdexcept\2|
-/^#[ 	]*include/s|\([<"/]\)stdiostr\.h\([">]\)|\1stdiostream\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_algb\.h\([">]\)|\1stl_algobase\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_allo\.h\([">]\)|\1stl_alloc\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_bvec\.h\([">]\)|\1stl_bvector\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_conf\.h\([">]\)|\1stl_config\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_cons\.h\([">]\)|\1stl_construct\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_dequ\.h\([">]\)|\1stl_deque\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_func\.h\([">]\)|\1stl_function\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_htab\.h\([">]\)|\1stl_hashtable\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_hfun\.h\([">]\)|\1stl_hash_fun\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_hmap\.h\([">]\)|\1stl_hash_map\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_hset\.h\([">]\)|\1stl_hash_set\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_iter\.h\([">]\)|\1stl_iterator\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_mmap\.h\([">]\)|\1stl_multimap\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_mset\.h\([">]\)|\1stl_multiset\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_nume\.h\([">]\)|\1stl_numeric\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_queu\.h\([">]\)|\1stl_queue\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_raw_\.h\([">]\)|\1stl_raw_storage_iter\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_relo\.h\([">]\)|\1stl_relops\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_slis\.h\([">]\)|\1stl_slist\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_stac\.h\([">]\)|\1stl_stack\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_temp\.h\([">]\)|\1stl_tempbuf\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_unin\.h\([">]\)|\1stl_uninitialized\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_vect\.h\([">]\)|\1stl_vector\.h\2|
-/^#[ 	]*include/s|\([<"/]\)streambu\.h\([">]\)|\1streambuf\.h\2|
-/^#[ 	]*include/s|\([<"/]\)strstrea\([">]\)|\1strstream\2|
-/^#[ 	]*include/s|\([<"/]\)strstrea\.h\([">]\)|\1strstream\.h\2|
-/^#[ 	]*include/s|\([<"/]\)typemacr\.h\([">]\)|\1typemacros\.h\2|
-/^#[ 	]*include/s|\([<"/]\)type_tra\.h\([">]\)|\1type_traits\.h\2|
-/^#[ 	]*include/s|\([<"/]\)_G_confi\.h\([">]\)|\1_G_config\.h\2|
-/^#[ 	]*include/s|\([<"/]\)NXConstS\.h\([">]\)|\1NXConstStr\.h\2|
-/^#[ 	]*include/s|\([<"/]\)objc-lis\.h\([">]\)|\1objc-list\.h\2|
-/^#[ 	]*include/s|\([<"/]\)typedstr\.h\([">]\)|\1typedstream\.h\2|
-/^#[ 	]*include/s|\([<"/]\)unchecke\.h\([">]\)|\1unchecked\.h\2|
Index: trunk/src/emx/include/longshrt.ls1
===================================================================
--- trunk/src/emx/include/longshrt.ls1	(revision 142)
+++ 	(revision )
@@ -1,49 +1,0 @@
-cpp/algorithm algorith
-cpp/AllocRing.h AllocRin.h
-cpp/BitString.h BitStrin.h
-cpp/builtinbuf.h builtinb.h
-cpp/exception exceptio
-cpp/functional function
-cpp/gen/SplayNode.ccP SplayNod.ccP
-cpp/gen/SplayNode.hP SplayNod.hP
-cpp/getpagesize.h getpages.h
-cpp/hashtable.h hashtabl.h
-cpp/Incremental.h Incremen.h
-cpp/indstream.h indstrea.h
-cpp/parsestream.h parsestr.h
-cpp/std/ldcomplex.h ldcomple.h
-cpp/stdexcept stdexcep
-cpp/stdiostream.h stdiostr.h
-cpp/stl_algobase.h stl_algb.h
-cpp/stl_alloc.h stl_allo.h
-cpp/stl_bvector.h stl_bvec.h
-cpp/stl_config.h stl_conf.h
-cpp/stl_construct.h stl_cons.h
-cpp/stl_deque.h stl_dequ.h
-cpp/stl_function.h stl_func.h
-cpp/stl_hashtable.h stl_htab.h
-cpp/stl_hash_fun.h stl_hfun.h
-cpp/stl_hash_map.h stl_hmap.h
-cpp/stl_hash_set.h stl_hset.h
-cpp/stl_iterator.h stl_iter.h
-cpp/stl_multimap.h stl_mmap.h
-cpp/stl_multiset.h stl_mset.h
-cpp/stl_numeric.h stl_nume.h
-cpp/stl_queue.h stl_queu.h
-cpp/stl_raw_storage_iter.h stl_raw_.h
-cpp/stl_relops.h stl_relo.h
-cpp/stl_slist.h stl_slis.h
-cpp/stl_stack.h stl_stac.h
-cpp/stl_tempbuf.h stl_temp.h
-cpp/stl_uninitialized.h stl_unin.h
-cpp/stl_vector.h stl_vect.h
-cpp/streambuf.h streambu.h
-cpp/strstream strstrea
-cpp/strstream.h strstrea.h
-cpp/typemacros.h typemacr.h
-cpp/type_traits.h type_tra.h
-cpp/_G_config.h _G_confi.h
-objc/NXConstStr.h NXConstS.h
-objc/objc-list.h objc-lis.h
-objc/typedstream.h typedstr.h
-unchecked.h unchecke.h
Index: trunk/src/emx/include/longshrt.ls2
===================================================================
--- trunk/src/emx/include/longshrt.ls2	(revision 142)
+++ 	(revision )
@@ -1,59 +1,0 @@
-cpp/algo.h
-cpp/algobase.h
-cpp/algorithm
-cpp/alloc.h
-cpp/bool.h
-cpp/builtinbuf.h
-cpp/bvector.h
-cpp/cmath
-cpp/CursesW.h
-cpp/deque
-cpp/deque.h
-cpp/function.h
-cpp/functional
-cpp/hashtable.h
-cpp/hash_map
-cpp/hash_map.h
-cpp/hash_set
-cpp/hash_set.h
-cpp/heap.h
-cpp/iostream.h
-cpp/iterator
-cpp/iterator.h
-cpp/libio.h
-cpp/list
-cpp/map
-cpp/memory
-cpp/minmax.h
-cpp/multimap.h
-cpp/multiset.h
-cpp/new
-cpp/numeric
-cpp/pair.h
-cpp/parsestream.h
-cpp/procbuf.h
-cpp/queue
-cpp/RNG.h
-cpp/rope
-cpp/rope.h
-cpp/set
-cpp/slist
-cpp/slist.h
-cpp/stack
-cpp/stack.h
-cpp/std/complext.h
-cpp/std.h
-cpp/stdexcept
-cpp/stl_algobase.h
-cpp/stl_bvector.h
-cpp/stl_config.h
-cpp/stl_hashtable.h
-cpp/stl_tree.h
-cpp/strstream
-cpp/tempbuf.h
-cpp/typeinfo
-cpp/type_traits.h
-cpp/utility
-cpp/vector
-cpp/vector.h
-objc/Object.h
Index: trunk/src/emx/include/make.cmd
===================================================================
--- trunk/src/emx/include/make.cmd	(revision 142)
+++ 	(revision )
@@ -1,15 +1,0 @@
-/* make.cmd */
-
-if stream('unchecked.h', 'C', 'QUERY EXISTS') == '',
-  |stream('cpp\stl_hash_set.h', 'C', 'QUERY EXISTS') == '' then do
-  say 'Do not run this procedure now.'
-  exit 1
-end
-
-'gfind . -type f -print|grep -e "^\(.*/\)*[^/.]\{9,\}\(\.[hc]\|\.cc\|\.hP\|\.ccP\|\)$" >make.$$1'
-'sed -f make1.sed make.$$1 >make.$$2'
-'sed -f make2.sed make.$$1 >longshrt.ls1'
-'gfind . -type f -print|grep -e "^\(.*/\)*[^/.]\+\(\.[hc]\|\.cc|\.hP\|\.ccP\|\)$"|xargs grep -l -f make.$$2 >longshrt.ls2'
-'sed -f make3.sed longshrt.ls1 >short.sed'
-'sed -f make4.sed longshrt.ls1 >long.sed'
-'del make.$$1 make.$$2 >nul'
Index: trunk/src/emx/include/make1.sed
===================================================================
--- trunk/src/emx/include/make1.sed	(revision 142)
+++ 	(revision )
@@ -1,2 +1,0 @@
-s/\./\\./g
-s!^\(.*/\)*\(.*\)$!^#[ 	]*include[ 	]*[<"]\\(.*/\\)*\2[>"]!
Index: trunk/src/emx/include/make2.sed
===================================================================
--- trunk/src/emx/include/make2.sed	(revision 142)
+++ 	(revision )
@@ -1,8 +1,0 @@
-s!^\(\(.*/\)*\)stl_algobase\.h$!\0 stl_algb.h!
-s!^\(\(.*/\)*\)stl_hashtable\.h$!\0 stl_htab.h!
-s!^\(\(.*/\)*\)stl_hash_fun\.h$!\0 stl_hfun.h!
-s!^\(\(.*/\)*\)stl_hash_map\.h$!\0 stl_hmap.h!
-s!^\(\(.*/\)*\)stl_hash_set\.h$!\0 stl_hset.h!
-s!^\(\(.*/\)*\)stl_multimap\.h$!\0 stl_mmap.h!
-s!^\(\(.*/\)*\)stl_multiset\.h$!\0 stl_mset.h!
-/ /!s!^\(\(.*/\)*\)\([^.][^.][^.][^.][^.][^.][^.][^.]\)[^.][^.]*\(\.[hc]\|\.cc\|\.hP\|\.ccP\|\)$!\0 \3\4!
Index: trunk/src/emx/include/make3.sed
===================================================================
--- trunk/src/emx/include/make3.sed	(revision 142)
+++ 	(revision )
@@ -1,2 +1,0 @@
-s/\./\\./g
-s!^\(.*/\)*\(.*\) \(.*\)$!/^#[ 	]*include/s|\\([<"/]\\)\2\\([">]\\)|\\1\3\\2|!
Index: trunk/src/emx/include/make4.sed
===================================================================
--- trunk/src/emx/include/make4.sed	(revision 142)
+++ 	(revision )
@@ -1,2 +1,0 @@
-s/\./\\./g
-s!^\(.*/\)*\(.*\) \(.*\)$!/^#[ 	]*include/s|\\([<"/]\\)\3\\([">]\\)|\\1\2\\2|!
Index: trunk/src/emx/include/short.cmd
===================================================================
--- trunk/src/emx/include/short.cmd	(revision 142)
+++ 	(revision )
@@ -1,37 +1,0 @@
-/* short.cmd */
-
-'@echo off'
-
-call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
-call SysLoadFuncs
-
-if SysSearchPath('PATH', 'sed.exe') == '' then do
-  say 'sed.exe not found -- see INSTALL.DOC'
-  exit
-end
-
-do while lines('longshrt.ls2')
-  file = translate(linein('longshrt.ls2'), '\', '/')
-  if stream(file, 'C', 'QUERY EXISTS') \= '' then do
-    say 'Patching' file
-    'sed -f short.sed >tmp' file
-    if rc \= 0 then do
-      say 'sed failed!'
-      exit
-    end
-    'touch -r' file 'tmp'
-    'del' file
-    'move tmp' file '>nul'
-  end
-end
-
-say 'Renaming files'
-do while lines('longshrt.ls1')
-  line = linein('longshrt.ls1')
-  parse var line long short
-  file = translate(long, '\', '/')
-  if stream(file, 'C', 'QUERY EXISTS') \= '' then
-    'ren' file short
-end
-
-say 'Done'
Index: trunk/src/emx/include/short.sed
===================================================================
--- trunk/src/emx/include/short.sed	(revision 142)
+++ 	(revision )
@@ -1,49 +1,0 @@
-/^#[ 	]*include/s|\([<"/]\)algorithm\([">]\)|\1algorith\2|
-/^#[ 	]*include/s|\([<"/]\)AllocRing\.h\([">]\)|\1AllocRin\.h\2|
-/^#[ 	]*include/s|\([<"/]\)BitString\.h\([">]\)|\1BitStrin\.h\2|
-/^#[ 	]*include/s|\([<"/]\)builtinbuf\.h\([">]\)|\1builtinb\.h\2|
-/^#[ 	]*include/s|\([<"/]\)exception\([">]\)|\1exceptio\2|
-/^#[ 	]*include/s|\([<"/]\)functional\([">]\)|\1function\2|
-/^#[ 	]*include/s|\([<"/]\)SplayNode\.ccP\([">]\)|\1SplayNod\.ccP\2|
-/^#[ 	]*include/s|\([<"/]\)SplayNode\.hP\([">]\)|\1SplayNod\.hP\2|
-/^#[ 	]*include/s|\([<"/]\)getpagesize\.h\([">]\)|\1getpages\.h\2|
-/^#[ 	]*include/s|\([<"/]\)hashtable\.h\([">]\)|\1hashtabl\.h\2|
-/^#[ 	]*include/s|\([<"/]\)Incremental\.h\([">]\)|\1Incremen\.h\2|
-/^#[ 	]*include/s|\([<"/]\)indstream\.h\([">]\)|\1indstrea\.h\2|
-/^#[ 	]*include/s|\([<"/]\)parsestream\.h\([">]\)|\1parsestr\.h\2|
-/^#[ 	]*include/s|\([<"/]\)ldcomplex\.h\([">]\)|\1ldcomple\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stdexcept\([">]\)|\1stdexcep\2|
-/^#[ 	]*include/s|\([<"/]\)stdiostream\.h\([">]\)|\1stdiostr\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_algobase\.h\([">]\)|\1stl_algb\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_alloc\.h\([">]\)|\1stl_allo\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_bvector\.h\([">]\)|\1stl_bvec\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_config\.h\([">]\)|\1stl_conf\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_construct\.h\([">]\)|\1stl_cons\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_deque\.h\([">]\)|\1stl_dequ\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_function\.h\([">]\)|\1stl_func\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_hashtable\.h\([">]\)|\1stl_htab\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_hash_fun\.h\([">]\)|\1stl_hfun\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_hash_map\.h\([">]\)|\1stl_hmap\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_hash_set\.h\([">]\)|\1stl_hset\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_iterator\.h\([">]\)|\1stl_iter\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_multimap\.h\([">]\)|\1stl_mmap\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_multiset\.h\([">]\)|\1stl_mset\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_numeric\.h\([">]\)|\1stl_nume\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_queue\.h\([">]\)|\1stl_queu\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_raw_storage_iter\.h\([">]\)|\1stl_raw_\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_relops\.h\([">]\)|\1stl_relo\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_slist\.h\([">]\)|\1stl_slis\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_stack\.h\([">]\)|\1stl_stac\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_tempbuf\.h\([">]\)|\1stl_temp\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_uninitialized\.h\([">]\)|\1stl_unin\.h\2|
-/^#[ 	]*include/s|\([<"/]\)stl_vector\.h\([">]\)|\1stl_vect\.h\2|
-/^#[ 	]*include/s|\([<"/]\)streambuf\.h\([">]\)|\1streambu\.h\2|
-/^#[ 	]*include/s|\([<"/]\)strstream\([">]\)|\1strstrea\2|
-/^#[ 	]*include/s|\([<"/]\)strstream\.h\([">]\)|\1strstrea\.h\2|
-/^#[ 	]*include/s|\([<"/]\)typemacros\.h\([">]\)|\1typemacr\.h\2|
-/^#[ 	]*include/s|\([<"/]\)type_traits\.h\([">]\)|\1type_tra\.h\2|
-/^#[ 	]*include/s|\([<"/]\)_G_config\.h\([">]\)|\1_G_confi\.h\2|
-/^#[ 	]*include/s|\([<"/]\)NXConstStr\.h\([">]\)|\1NXConstS\.h\2|
-/^#[ 	]*include/s|\([<"/]\)objc-list\.h\([">]\)|\1objc-lis\.h\2|
-/^#[ 	]*include/s|\([<"/]\)typedstream\.h\([">]\)|\1typedstr\.h\2|
-/^#[ 	]*include/s|\([<"/]\)unchecked\.h\([">]\)|\1unchecke\.h\2|
Index: trunk/src/emx/include/stdlib.h
===================================================================
--- trunk/src/emx/include/stdlib.h	(revision 142)
+++ trunk/src/emx/include/stdlib.h	(revision 143)
@@ -248,5 +248,4 @@
 void _scrsize (int *);
 void _searchenv (__const__ char *, __const__ char *, char *);
-int _setsyserrno (int);
 void _sfnlwr (__const__ char *);
 unsigned _sleep2 (unsigned);
@@ -258,5 +257,4 @@
 unsigned long long _strtoull (__const__ char *, char **, int);
 char _swchar (void);
-int _syserrno (void);
 _uldiv_t _uldiv (unsigned long, unsigned long);
 _ulldiv_t _ulldiv (unsigned long long, unsigned long long);
Index: trunk/src/emx/include/sys/hw.h
===================================================================
--- trunk/src/emx/include/sys/hw.h	(revision 142)
+++ trunk/src/emx/include/sys/hw.h	(revision 143)
@@ -7,7 +7,4 @@
 extern "C" {
 #endif
-
-void *_memaccess (unsigned, unsigned, int);
-int _portaccess (unsigned, unsigned);
 
 unsigned _inp8 (unsigned);